local sliderAmount = 1
local currentPriceAmount = 1
local flaskPrice = 5
local potionPrice = 5

local flaskStarBuyAmount = 9
local potionStarBuyAmount = 3
local flaskOtherBuyAmount = 10
local potionOtherBuyAmount = 10

local STARMAX = 3
local OTHERMAX = 10

local function Tab_OnClick(self)
	PanelTemplates_SetTab(self:GetParent())	
	
	QOLBloodTraderFrameTab1.content:Hide()
	QOLBloodTraderFrameTab2.content:Hide()
	self.content:Show()
end

local function SetTabs( frame, numTabs, ... )
	frame.numTabs = numTabs
	local contents = {}
	local frameName = frame:GetName()

	for i = 1, numTabs do
		local tab = CreateFrame("Button", frameName.."Tab"..i, frame, "CharacterFrameTabButtonTemplate")
		tab:SetID(i)
		tab:SetText(select(i, ...))
		tab:SetScript("OnClick", Tab_OnClick)

		tab.content = CreateFrame("Frame", nil, QOLBloodTraderFrame.ContentFrame)
		tab.content:SetPoint("TOPLEFT", QOLBloodTraderFrame.ContentFrame, "TOPLEFT")
		tab.content:SetSize(300, 350)
		tab.content:Hide()

		table.insert(contents, tab.content)

		if i == 1 then
			tab:SetPoint("TOPLEFT", QOLBloodTraderFrame, "BOTTOMLEFT", 5, 7)
		else
			tab:SetPoint("TOPLEFT", _G[frameName.."Tab"..(i-1)], "TOPRIGHT", -14, 0)
		end
	end

	Tab_OnClick(_G[frameName.."Tab1"])

	return unpack(contents)
end

local function CreateButton(parent, parent2, template, tooltip, width, height, price, hook1, hook2, offsetX, offsetY, texture, item)
	local button = CreateFrame("Button", item.."Global", parent, template)
	button:SetPoint(hook1, parent2, hook2, offsetX, offsetY)
	button:SetSize(width, height)
	button:SetNormalFontObject("GameFontNormalLarge")
	button:SetHighlightFontObject("GameFontHighlightLarge")
	button:SetNormalTexture(texture)
	button.tooltipText = tooltip
	button:SetText(price)
	button:GetFontString():SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -20, 2)
	button.bloodTexture = CreateFrame("Button", nil, button, "GameMenuButtonTemplate")
	button.bloodTexture:Show()
	button.bloodTexture:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", -4, 3.5)
	button.bloodTexture:SetSize(15, 15)
	button.bloodTexture:Disable()
	button.bloodTexture:SetDisabledTexture(GetItemIcon(124124)) -- blood icon

	button:SetScript("OnMouseDown", function(self, button) buy(item) end)
	return button
end

local function updatePrices()
		local newAmount = AmountSliderFrame:GetValue()
		newAmount = math.floor(newAmount)
		if newAmount == currentPriceAmount then
			return
		end

		currentPriceAmount = newAmount
		AmountSliderFrameText:SetText(tostring(newAmount));

		local amount = currentPriceAmount
		local flaskStarAmount = 7 * amount
		local potionStarAmount = amount
		local flaskDifference = flaskStarAmount % STARMAX
		local potionDifference = potionStarAmount % STARMAX
		local flaskStarBuy = flaskStarAmount
		local potionStarBuy = potionStarAmount
		if flaskDifference >= 1 then
			flaskStarBuy = flaskStarAmount + (STARMAX - flaskDifference)
		end
		if potionDifference >= 1 then
			potionStarBuy = potionStarAmount + (STARMAX - potionDifference)
		end
		local flaskOtherAmount = 10 * amount
		local flaskStarPrice = flaskStarBuy / STARMAX
		local flaskOtherPrice = flaskOtherAmount / OTHERMAX
		local potionOtherAmount = 2 * amount
		local potionOtherdifference = potionOtherAmount % OTHERMAX
		local potionOtherBuy = potionOtherAmount
		if potionOtherdifference >= 1 then
			potionOtherBuy = potionOtherAmount + (OTHERMAX - potionOtherdifference)
		end
		local potionStarPrice = potionStarBuy / STARMAX
		local potionOtherPrice = potionOtherBuy / OTHERMAX

		flaskPrice = flaskStarPrice + 2*flaskOtherPrice
		potionPrice = potionStarPrice + 2*potionOtherPrice
		flaskOtherBuyAmount = flaskOtherAmount
		flaskStarBuyAmount = flaskStarBuy
		potionStarBuyAmount = potionStarBuy
		potionOtherBuyAmount = potionOtherBuy

		STRGlobal:SetText(flaskPrice)
		STAGlobal:SetText(flaskPrice)
		AGIGlobal:SetText(flaskPrice)
		INTGlobal:SetText(flaskPrice)

		WARGlobal:SetText(potionPrice)
		GRACEGlobal:SetText(potionPrice)
		UNBENDINGGlobal:SetText(potionPrice)
		LEYGlobal:SetText(potionPrice)
end

function initVars()
 	if PlayerBuyAmount == nil then
   		PlayerBuyAmount = 1; -- This is the first time this addon is loaded; initialize the count to 1.
	end
	sliderAmount = PlayerBuyAmount
	updatePrices()
end

function InitQOLBloodTrader() 
  QOLBloodTraderFrame.title = QOLBloodTraderFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
  QOLBloodTraderFrame.title:SetPoint("CENTER", QOLBloodTraderFrameTitleBG, "CENTER", 0, 0)
  QOLBloodTraderFrame.title:SetText("Slarky's QOLBloodtrader")

  QOLBloodTraderFrame.ContentFrame = CreateFrame("Frame", nil, QOLBloodTraderFrame)
  QOLBloodTraderFrame.ContentFrame:SetSize(300, 350)
  QOLBloodTraderFrame.ContentFrame:SetPoint("TOPLEFT", QOLBloodTraderFrameDialogBG, "TOPLEFT", -3, 4)

  local content1, content2 = SetTabs(QOLBloodTraderFrame, 2, "Alchemy", "Cooking")

  local buttonX = 60
  local buttonY = 60

  local STRtooltip = "Flask of the Countless Armies"
  local INTtooltip = "Flask of the Whispered Pact"
  local AGItooltip = "Flask of the Seventh Demon"
  local STAtooltip = "Flask of Ten Thousand Scars"
  local WARtooltip = "Potion of the Old War"
  local UNBENDINGtooltip = "Unbending Potion"
  local GRACEtooltip = "Potion of Deadly Grace"
  local LEYtooltip = "Leytorrent Potion"

  local language = GetLocale()

  if language == "deDE" then
  	  STRtooltip = "Fläschchen der zahllosen Armeen"
	  INTtooltip = "Fläschchen des geflüsterten Pakts"
	  AGItooltip = "Fläschchen des Siebten Dämons"
	  STAtooltip = "Fläschchen der zehntausend Narben"
	  WARtooltip = "Trank des Alten Krieges"
	  UNBENDINGtooltip = "Unbeugsamer Trank"
	  GRACEtooltip = "Trank der tödlichen Anmut"
	  LEYtooltip = "Leywirbeltrank"
  end

  local blood_icon = GetItemIcon(124124)

  local buttonsOffsetY = -120
  local sliderMax = 50

  QOLBloodTraderFrame.ContentFrame.AmountSlider = CreateFrame('Slider', 'AmountSliderFrame', QOLBloodTraderFrame.ContentFrame, 'OptionsSliderTemplate')
  QOLBloodTraderFrame.ContentFrame.AmountSlider:SetPoint("TOP", QOLBloodTraderFrame.ContentFrame, "TOP", -5, -50)
  QOLBloodTraderFrame.ContentFrame.AmountSlider:SetWidth(200)
  QOLBloodTraderFrame.ContentFrame.AmountSlider:SetHeight(30)
  QOLBloodTraderFrame.ContentFrame.AmountSlider:SetValueStep(1)
  QOLBloodTraderFrame.ContentFrame.AmountSlider:SetMinMaxValues(1, sliderMax)  
  QOLBloodTraderFrame.ContentFrame.AmountSlider:SetValue(1)
  QOLBloodTraderFrame.ContentFrame.AmountSlider:SetOrientation('HORIZONTAL')
  AmountSliderFrameLow:SetText('1');
  AmountSliderFrameHigh:SetText(tostring(sliderMax).." "); 
  AmountSliderFrameText:SetText(tostring(sliderAmount));
  QOLBloodTraderFrame.ContentFrame.AmountSlider:SetScript("OnValueChanged", updatePrices)
  QOLBloodTraderFrame.ContentFrame.AmountSlider:Show()

  -- Create Buttons
  content1.FlaskSTRButton = CreateButton(content1, content1, 
  	"GameMenuButtonTemplate", STRtooltip, buttonX, buttonY, 5, "CENTER", "TOP", 
  	-65, buttonsOffsetY, "Interface\\Icons\\inv_alchemy_70_flask03red", "STR")

  content1.FlaskINTButton = CreateButton(content1, content1.FlaskSTRButton, 
  	"GameMenuButtonTemplate", INTtooltip, buttonX, buttonY, 5, "TOP", "BOTTOM", 
  	0, -10, "Interface\\Icons\\inv_alchemy_70_flask03purple", "INT")

  content1.FlaskAGIButton = CreateButton(content1, content1.FlaskINTButton, 
  	"GameMenuButtonTemplate", AGItooltip, buttonX, buttonY, 5, "TOP", "BOTTOM", 
  	0, -10, "Interface\\Icons\\inv_alchemy_70_flask03orange", "AGI")

  content1.FlaskSTAButton = CreateButton(content1, content1.FlaskAGIButton, 
  	"GameMenuButtonTemplate", STAtooltip, buttonX, buttonY, 5, "TOP", "BOTTOM", 
  	0, -10, "Interface\\Icons\\inv_alchemy_70_flask03green", "STA")

  ----------------------------------------------------------------------------------

  content1.FlaskWARButton = CreateButton(content1, content1, 
  	"GameMenuButtonTemplate", WARtooltip, buttonX, buttonY, 3, "CENTER", "TOP", 
  	buttonX, buttonsOffsetY, "Interface\\Icons\\inv_alchemy_70_orange", "WAR")

  content1.FlaskUNBENDINGButton = CreateButton(content1, content1.FlaskWARButton, 
  	"GameMenuButtonTemplate", UNBENDINGtooltip, buttonX, buttonY, 3, "TOP", "BOTTOM", 
  	0, -10, "Interface\\Icons\\inv_alchemy_70_flask04", "UNBENDING")

  content1.FlaskGRACEButton = CreateButton(content1, content1.FlaskUNBENDINGButton, 
  	"GameMenuButtonTemplate", GRACEtooltip, buttonX, buttonY, 3, "TOP", "BOTTOM", 
  	0, -10, "Interface\\Icons\\inv_alchemy_70_flask02", "GRACE")

  content1.FlaskLEYButton = CreateButton(content1, content1.FlaskGRACEButton, 
  	"GameMenuButtonTemplate", LEYtooltip, buttonX, buttonY, 3, "TOP", "BOTTOM", 
  	0, -10, "Interface\\Icons\\inv_alchemy_70_flask01", "LEY")

  initVars()
end

function CheckBloodTrader()
  local BLOODTRADER_NPCID = 115264
  local guid = UnitGUID("npc")
  if not guid then return end
  local _, _, _, _, _, npcid = strsplit("-", guid)
  if not npcid then return end
  if tonumber(npcid) ~= BLOODTRADER_NPCID then return end
  QOLBloodTraderFrame:Show()
end

function closeIfOpen()
	QOLBloodTraderFrame:Hide()
end

function buy(item)
	if item == "STR" then
		BuyMerchantItem(18, flaskStarBuyAmount)  -- Star
		BuyMerchantItem(14, flaskOtherBuyAmount) -- Aeth
		BuyMerchantItem(16, flaskOtherBuyAmount) -- Fox
	elseif item == "STA" then
		BuyMerchantItem(18, flaskStarBuyAmount)  -- Star
		BuyMerchantItem(14, flaskOtherBuyAmount) -- Aeth
		BuyMerchantItem(15, flaskOtherBuyAmount) -- Dream
	elseif item == "AGI" then
		BuyMerchantItem(18, flaskStarBuyAmount)  -- Star
		BuyMerchantItem(16, flaskOtherBuyAmount) -- Fox
		BuyMerchantItem(17, flaskOtherBuyAmount) -- Fjarn
	elseif item == "INT" then
		BuyMerchantItem(18, flaskStarBuyAmount)  -- Star
		BuyMerchantItem(17, flaskOtherBuyAmount) -- Fjarn
		BuyMerchantItem(15, flaskOtherBuyAmount) -- Dream
	elseif item == "WAR" then
		BuyMerchantItem(18, potionStarBuyAmount)  -- Star
		BuyMerchantItem(16, potionOtherBuyAmount)  -- Fox
		BuyMerchantItem(17, potionOtherBuyAmount)  -- Fjarn
	elseif item == "UNBENDING" then
		BuyMerchantItem(18, potionStarBuyAmount)  -- Star
		BuyMerchantItem(16, potionOtherBuyAmount)  -- Fox
		BuyMerchantItem(14, potionOtherBuyAmount)  -- Aeth
	elseif item == "GRACE" then
		BuyMerchantItem(18, potionStarBuyAmount)  -- Star
		BuyMerchantItem(17, potionOtherBuyAmount)  -- Fjarn
		BuyMerchantItem(15, potionOtherBuyAmount)  -- Dream
	elseif item == "LEY" then
		BuyMerchantItem(18, potionStarBuyAmount)  -- Star
		BuyMerchantItem(14, potionOtherBuyAmount) -- Aeth
		BuyMerchantItem(15, potionOtherBuyAmount) -- Dream
	end
end

MerchantFrame:HookScript("OnShow", CheckBloodTrader)
MerchantFrame:HookScript("OnHide", closeIfOpen)
